{**************************************}
{ Copyright (C) MarinovSoft 2000-2006  }
{ http://marinovsoft.narod.ru          }
{ super386@rambler.ru                  }
{**************************************}
Unit SysInf;
Interface
Uses Windows;
type Char60 = {array [0..60] of char}string;
type
  TDriverInfo = record
 Present:boolean;
 VolLabel:string;
 VolNumber:array[1..9] of char;
 DriveLetter:char;
 DrvSize:Comp;
 DrvFreeSpace:Comp;
 DriverType:char60{array[0..60] of char};
  end;
type
  ArrayTDriverInfo = array ['A'..'Z'] of TDriverInfo;

Function FindWindowsDir: String;          {pp }
Function GetOperatingSystem: String;      {p樮 ⥬}
Function GetTdriverInfo:ArrayTDriverInfo; {᮪ ⥫}
Function GetSysVersion:string;

Function PutUserName:String;
Function PutCompName:String;
Function PutWinDir:String;
Function PutSysDir:String;

Implementation

Uses WinProcs, SysUtils,vpSyslow,vpUtils,strings;
type
  tlargeinteger = tquad;
  plargeinteger = ^tlargeinteger;

Const

  { operating system constants }
  cOsUnknown  = - 1;
  cOsWin95=  0;
  cOsWin98=  1;
  cOsWin98SE  =  2;
  cOsWinME=  3;
  cOsWinNT=  4;
  cOsWin2000  =  5;
  cOsWhistler =  6;
Const
  DrvType: array[drive_Unknown..drive_RAMDisk] of char60 = (
  'Unknown drive',
  'Drive not exist',
  'Floppy drive',
  'Hard Disk drive',
  'Network drive',  
  'CD-ROM drive',
  'RAM drive');
var
  GetDiskFreeSpaceEx: function (Directory: PChar; var FreeAvailable,
  TotalSpace: TLargeInteger; TotalFree: PLargeInteger): Bool stdcall = nil;

function GetDiskFreeSpaceA(lpRootPathName: PAnsiChar;
  var lpSectorsPerCluster, lpBytesPerSector, lpNumberOfFreeClusters, lpTotalNumberOfClusters: DWORD): BOOL;
  stdcall; external kernel32 name 'GetDiskFreeSpaceA';
function BackfillGetDiskFreeSpaceEx(Directory: PChar; var FreeAvailable,
 TotalSpace: TLargeInteger; TotalFree: PLargeInteger): Bool; stdcall;
var
  SectorsPerCluster, BytesPerSector, FreeClusters, TotalClusters: Longint;
  Temp: tquad;
  Dir: PChar;
begin
  if Directory <> nil then
 Dir := Directory
  else
 Dir := nil;
  Result := GetDiskFreeSpaceA(Dir, SectorsPerCluster, BytesPerSector,
 FreeClusters, TotalClusters);
  Temp := SectorsPerCluster * BytesPerSector;
  FreeAvailable := Temp * FreeClusters;
  TotalSpace := Temp * TotalClusters;
end;

function InternalGetDiskSpace(Drive: Byte;
  var TotalSpace, FreeSpaceAvailable: tquad): Bool;
var
  RootPath: array[0..4] of Char;
  RootPtr: PChar;
begin
  RootPtr := nil;
  if Drive > 0 then
  begin
 RootPath[0] := Char(Drive + $40);
 RootPath[1] := ':';
 RootPath[2] := '\';
 RootPath[3] := #0;
 RootPtr := RootPath;
  end;
  Result := GetDiskFreeSpaceEx(RootPtr, FreeSpaceAvailable, TotalSpace, nil);
end;

function DiskFree(Drive: Byte): tquad;
var
  TotalSpace: tquad;
begin
  if not InternalGetDiskSpace(Drive, TotalSpace, Result) then
 Result := -1;
end;
function DiskSize(Drive: Byte): tquad;
var
  FreeSpace: tquad;
begin
  if not InternalGetDiskSpace(Drive, Result, FreeSpace) then
 Result := -1;
end;
procedure InitDriveSpacePtr;
var
  Kernel: THandle;
begin
  Kernel := GetModuleHandle(Windows.Kernel32);
  if Kernel <> 0 then
 @GetDiskFreeSpaceEx := GetProcAddress(Kernel, 'GetDiskFreeSpaceExA');
  if not Assigned(GetDiskFreeSpaceEx) then
 @GetDiskFreeSpaceEx := @BackfillGetDiskFreeSpaceEx;
end;

Function FindWindowsDir : String;
Var
  pWindowsDir : Array [0..1000] Of Char;
  sWindowsDir : String;
Begin
  GetWindowsDirectory (@pWindowsDir, MAX_PATH);
  sWindowsDir := StrPas (pWindowsDir);
  Result := sWindowsDir ;
End;

Function GetOperatingSystem : String;
const
  SysName: Array[- 1..6] Of Array [0..7] Of Char = (
  'Unknown', 'Win95', 'Win98', 'Win98SE', 'WinMe', 'WinNT', 'Win2000', 'Whistler'
  );
Var
  osVerInfo     : TOSVersionInfo;
  majorVer, minorVer : Integer;
Begin
  Result := SysName[cOsUnknown];
  { set operating system type flag }
  osVerInfo.DwOsVersionInfoSize := SizeOf(TOSVersionInfo);
  If Getversionex(osVerInfo) Then
  Begin
 majorVer := osVerInfo.DwMajorVersion;
 minorVer := osVerInfo.DwMinorVersion;
 Case osVerInfo.DwPlatformId Of
Ver_Platform_Win32_Nt : { Windows NT/2000 }
Begin
  If majorVer <= 4 Then
 Result := SysName[cOsWinNT]
  Else
 If (majorVer = 5) And (minorVer= 0) Then
Result := SysName[cOsWin2000]
 Else
If (majorVer = 5) And (minorVer = 1) Then
  Result := SysName[cOsWhistler]
Else
  Result := SysName[cOsUnknown];
End;
Ver_Platform_Win32_Windows :    { Windows 9x/ME }
Begin
  If (majorVer = 4) And (minorVer = 0) Then
 Result := SysName[cOsWin95]
  Else
 If (majorVer = 4) And (minorVer = 10) Then
 Begin
If osVerInfo.Szcsdversion[1] = 'A' Then
  Result := SysName[cOsWin98SE]
Else
  Result := SysName[cOsWin98];
 End
 Else
If (majorVer = 4) And (minorVer = 90) Then
  Result := SysName[cOsWinME]
Else
  Result := SysName[cOsUnknown];
End;
Else
  Result := SysName[cOsUnknown];
 End;
  End
  Else
 Result := SysName[cOsUnknown];
End;

Function GetSysVersion:string;
const
   separator:char='.';
var
   sysVer:TOSVersionInfo;
   verbuild:longint;
begin
   sysVer.DwOsVersionInfoSize := SizeOf(TOSVersionInfo);
   getVersionex(sysVer);
   if sysver.dwPlatformid=VER_PLATFORM_WIN32_NT then
      verbuild:=sysver.dwbuildnumber
   else
      verbuild:=loword(sysver.dwbuildnumber);
   with sysVer do Result:=Inttostr(dwMajorversion)+
      separator+Inttostr(dwminorversion)+separator+
      inttostr(verbuild)+' '+szCSDVersion;
end;
Function GetTDriverInfo:ArrayTDriverInfo;
var
  Drives:DriveSet;
  Drive:Char;
const
  PDrive:array[1..4] of Char='C:\'#0;
begin
  GetValidDrives(Drives);
  For Drive:= 'A' to 'Z' do with Result[drive] do
 if Drive in Drives then
begin
  Present:=True;
  Vollabel:=getVolumeLabel(drive);
  DriveLetter:=Drive;
  DrvSize:=DiskSize(ord(Drive)-$40);
  DrvFreeSpace:=DiskFree(ord(Drive)-$40);
  PDrive[1]:=Drive;
  DriverType:=DrvType[Windows.GetDriveType(@PDrive)];
  end
 else
begin
  Present:=False;
end;
end;
function PutUserName:string;
var nSize:Dword;
    Stroka:Lpstr;
begin
   Result:='';
   New(Stroka);
   nSize:=512;
   Windows.GetUserName(Stroka,nSize);
   Result:=strpas(stroka);
   Dispose(Stroka);
end;
function PutCompName:string;
Const
    nSize:Dword=MAX_ComputerName_Length+1;
var 
    Stroka:Lpstr;
begin
   Result:='';
   New(Stroka);
   Windows.GetComputerName(Stroka,nSize);
   Result:=strpas(stroka);
   Dispose(Stroka);
end;

Function PutWinDir:String;
const
  cbBuf:Integer=255;
var 
   Stroka:Lpstr;
begin
   New(Stroka);
   GetWindowsDirectory(Stroka,cbBuf);
   Result:=StrPas(Stroka);
   Dispose(Stroka);
end;
Function PutSysDir:String;
const
  cbBuf:Integer=255;
var 
   Stroka:Lpstr;
begin
   New(Stroka);
   GetSystemDirectory(Stroka,cbBuf);
   Result:=StrPas(Stroka);
   Dispose(Stroka);
end;

begin
  InitDriveSpacePtr;
End.
